﻿class Lander extends MovieClip{
	public var Landed:Boolean;
	private var left:Boolean;
	private var right:Boolean;
	private var active:Boolean;
	private var Gravity:Number;
	private var Thrust:Number;
	private var Factor:Number;
	private var Fuel:Number;
	private var xAccel:Number;
	private var yAccel:Number;
	private var xVel:Number;
	private var yVel:Number;
	private var x0:Number;
	private var y0:Number;
	private var Propulsor:MovieClip;
	private var Pause:Boolean;
	private var time:Number;

	public function Lander() {
		initValues();
	}
	public function initValues() {
		Landed = false;
		left = false;
		right = false;
		active = false;
		Pause = true;
		Factor = .003;
		Gravity = 0;
		// m / s^2
		Fuel = 100;
		// 100 %
		Thrust = 0;
		// m / s^2
		xAccel = 0;
		// Sum of accel in x
		yAccel = 0;
		// Sum of accel in y
		xVel = 100; // m / s
		yVel = 0;
		y0 = 50;
		x0 = 400;
		_rotation = 0;
		gotoAndStop(1);
	}
	private function Move() {
		if (active && Fuel>0) {
			Fuel -= .1;
			Thrust = -20*Math.cos(_rotation*(Math.PI/180));
		} else {
			Thrust = 0;
		}
		xAccel = 20*Math.sin(_rotation*(Math.PI/180));
		yAccel = Thrust+Gravity;
		xVel += xAccel;
		yVel += yAccel;
		x0 += xVel * Factor;
		y0 += yVel * Factor;
		_x = x0;
		_y = y0;
	}
	private function CheckKeys() {
		active = true;
		if (Fuel>0) {
			if (Key.isDown(Key.UP) and Key.isDown(Key.RIGHT)) {
				Rocket(-10);
				_rotation += 1;
			} else if (Key.isDown(Key.UP) and Key.isDown(Key.LEFT)) {
				Rocket(10);
				_rotation -= 1;
			} else if (Key.isDown(Key.UP)) {
				Rocket(0);
			} else if (Key.isDown(Key.LEFT)) {
				Rocket(20);
				_rotation -= 2;
			} else if (Key.isDown(Key.RIGHT)) {
				Rocket(-20);
				_rotation += 2;
			} else {
				active = false;
				Rocket(0);
			}
		}
	}
	public function onEnterFrame() {
		if (not Pause) {
			if (not Landed) {
				Timer.start();
				CheckKeys();
				Move();
				if (not hasFuel()) {
					Propulsor.gotoAndStop(1);
				}
			} else {
				Timer.reset();
				Pause = true;
			}
		} else {
			Timer.pause();
		}
	}
	public function Rocket(angle:Number) {
		Propulsor._rotation = angle;
		if (active and hasFuel()) {
			Propulsor.gotoAndPlay("Fire");
		} else {
			Propulsor.gotoAndStop(1);
		}
	}
	public function hasFuel():Boolean {
		if (Fuel>0) {
			return true;
		} else {
			return false;
		}
	}
	private function hiSpeed():Boolean {
		if (getSpeed()>700) {
			return true;
		} else {
			return false;
		}
	}
	private function medSpeed():Boolean {
		if (getSpeed()>300) {
			return true;
		} else {
			return false;
		}
	}
	public function getFuel() {
		return Fuel;
	}
	public function getSpeed() {
		return Math.sqrt(Math.pow(xVel, 2)+Math.pow(yVel, 2));
	}
	public function getxVelocity() {
		return xVel;
	}
	public function getyVelocity() {
		return yVel;
	}
	public function setPause(p:Boolean):Void {
		Pause = p;
	}
	public function isPaused():Boolean {
		return Pause;
	}
	public function setGravity(g:Number):Void {
		Gravity = g;
	}
}
