﻿// Object Name: Internal Timer (Abstract Object)
// Programer: Víctor M. Ortiz Del Valle
class Timer {
	private static var pauseTime:Number;
	private static var pauseLength:Number;
	private static var startTime:Number;
	private static var startLength:Number;
	private static var timing:Boolean;
	
	public function Timer() {
		timing = false;
		startTime = 0;
		startLength = 0;
		pauseTime = 0;
		pauseLength = 0;
	}
	public static function start() {
		if (not timing) {
			startTime = getTimer();
			pauseLength += startTime - pauseTime;
			timing = true;
		}
	}
	public static function pause() {
		if (timing) {
			pauseTime = getTimer();
			startLength += pauseTime - startTime;
			timing = false;
		}
	}
	public static function reset() {
		if (not timing) {
			startTime = 0;
			startLength = 0;
			pauseTime = 0;
			pauseLength = 0;
		}
	}
	public static function getMillis() {
		if (not timing) {
			return startLength;
		}
		else {
			return getTimer() + startLength;
		}
	}
}
